Index: /trunk/sources/LibSVM/ParameterSelection.cs
===================================================================
--- /trunk/sources/LibSVM/ParameterSelection.cs	(revision 2414)
+++ /trunk/sources/LibSVM/ParameterSelection.cs	(revision 2415)
@@ -24,8 +24,8 @@
 namespace SVM
 {
-    /// <remarks>
+    /// <summary>
     /// This class contains routines which perform parameter selection for a model which uses C-SVC and
     /// an RBF kernel.
-    /// </remarks>
+    /// </summary>
     public static class ParameterSelection
     {
@@ -142,5 +142,7 @@
             Gamma = 0;
             double crossValidation = double.MinValue;
-            StreamWriter output = new StreamWriter("graph.txt");
+            StreamWriter output = null;
+            if(outputFile != null)
+                output = new StreamWriter(outputFile);
             for(int i=0; i<CValues.Count; i++)
                 for (int j = 0; j < GammaValues.Count; j++)
@@ -150,5 +152,6 @@
                     double test = Training.PerformCrossValidation(problem, parameters, nrfold);
                     Console.Write("{0} {1} {2}", parameters.C, parameters.Gamma, test);
-                    output.WriteLine("{0} {1} {2}", parameters.C, parameters.Gamma, test);
+                    if(output != null)
+                        output.WriteLine("{0} {1} {2}", parameters.C, parameters.Gamma, test);
                     if (test > crossValidation)
                     {
@@ -160,5 +163,6 @@
                     else Console.WriteLine();
                 }
-            output.Close();
+            if(output != null)
+                output.Close();
         }
         /// <summary>
@@ -207,5 +211,7 @@
             Gamma = 0;
             double maxScore = double.MinValue;
-            StreamWriter output = new StreamWriter(outputFile);
+            StreamWriter output = null;
+            if(outputFile != null)
+                output = new StreamWriter(outputFile);
             for (int i = 0; i < CValues.Count; i++)
                 for (int j = 0; j < GammaValues.Count; j++)
@@ -216,5 +222,6 @@
                     double test = Prediction.Predict(validation, "tmp.txt", model, false);
                     Console.Write("{0} {1} {2}", parameters.C, parameters.Gamma, test);
-                    output.WriteLine("{0} {1} {2}", parameters.C, parameters.Gamma, test);
+                    if(output != null)
+                        output.WriteLine("{0} {1} {2}", parameters.C, parameters.Gamma, test);
                     if (test > maxScore)
                     {
@@ -226,5 +233,6 @@
                     else Console.WriteLine();
                 }
-            output.Close();
+            if(output != null)
+                output.Close();
         }
     }
Index: /trunk/sources/LibSVM/PerformanceEvaluator.cs
===================================================================
--- /trunk/sources/LibSVM/PerformanceEvaluator.cs	(revision 2414)
+++ /trunk/sources/LibSVM/PerformanceEvaluator.cs	(revision 2415)
@@ -21,10 +21,11 @@
 using System.Collections.Generic;
 using System.IO;
+using System.Globalization;
 
 namespace SVM
 {
-    /// <remarks>
+    /// <summary>
     /// Class encoding a member of a ranked set of labels.
-    /// </remarks>
+    /// </summary>
     public class RankPair : IComparable<RankPair>
     {
@@ -138,7 +139,7 @@
     }
 
-    /// <remarks>
+    /// <summary>
     /// Class which evaluates an SVM model using several standard techniques.
-    /// </remarks>
+    /// </summary>
     public class PerformanceEvaluator
     {
@@ -185,6 +186,6 @@
         /// <param name="model">Model to evaluate</param>
         /// <param name="problem">Problem to evaluate</param>
-        /// <param name="label">Label to be evaluate for</param>
-        public PerformanceEvaluator(Model model, Problem problem, double label) : this(model, problem, label, "tmp.results") { }
+        /// <param name="category">Label to be evaluate for</param>
+        public PerformanceEvaluator(Model model, Problem problem, double category) : this(model, problem, category, "tmp.results") { }
         /// <summary>
         /// Constructor.
@@ -220,5 +221,5 @@
             int confidenceIndex = -1;
             for (int i = 1; i < parts.Length; i++)
-                if (double.Parse(parts[i]) == category)
+                if (double.Parse(parts[i], CultureInfo.InvariantCulture) == category)
                 {
                     confidenceIndex = i;
@@ -229,6 +230,6 @@
             {
                 parts = input.ReadLine().Split(new char[] { ' ' }, StringSplitOptions.RemoveEmptyEntries);
-                double confidence = double.Parse(parts[confidenceIndex]);
-                _data.Add(new RankPair(confidence, labels[i]));
+                double confidence = double.Parse(parts[confidenceIndex], CultureInfo.InvariantCulture);
+                _data.Add(new RankPair(confidence, labels[i] == category ? 1 : 0));
             }
             input.Close();
Index: /trunk/sources/LibSVM/PrecomputedKernel.cs
===================================================================
--- /trunk/sources/LibSVM/PrecomputedKernel.cs	(revision 2414)
+++ /trunk/sources/LibSVM/PrecomputedKernel.cs	(revision 2415)
@@ -23,7 +23,7 @@
 namespace SVM
 {
-    /// <remarks>
+    /// <summary>
     /// Class encapsulating a precomputed kernel, where each position indicates the similarity score for two items in the training data.
-    /// </remarks>
+    /// </summary>
     [Serializable]
     public class PrecomputedKernel
@@ -42,4 +42,40 @@
             _rows = _similarities.GetLength(0);
             _columns = _similarities.GetLength(1);
+        }
+
+        /// <summary>
+        /// Constructor.
+        /// </summary>
+        /// <param name="nodes">Nodes for self-similarity analysis</param>
+        /// <param name="param">Parameters to use when computing similarities</param>
+        public PrecomputedKernel(List<Node[]> nodes, Parameter param)
+        {
+            _rows = nodes.Count;
+            _columns = _rows;
+            _similarities = new float[_rows, _columns];
+            for (int r = 0; r < _rows; r++)
+            {
+                for (int c = 0; c < r; c++)
+                    _similarities[r, c] = _similarities[c, r];
+                _similarities[r, r] = 1;
+                for (int c = r + 1; c < _columns; c++)
+                    _similarities[r, c] = (float)Kernel.KernelFunction(nodes[r], nodes[c], param);
+            }
+        }
+
+        /// <summary>
+        /// Constructor.
+        /// </summary>
+        /// <param name="rows">Nodes to use as the rows of the matrix</param>
+        /// <param name="columns">Nodes to use as the columns of the matrix</param>
+        /// <param name="param">Parameters to use when compute similarities</param>
+        public PrecomputedKernel(List<Node[]> rows, List<Node[]> columns, Parameter param)
+        {
+            _rows = rows.Count;
+            _columns = columns.Count;
+            _similarities = new float[_rows, _columns];
+            for (int r = 0; r < _rows; r++)
+                for (int c = 0; c < _columns; c++)
+                    _similarities[r, c] = (float)Kernel.KernelFunction(rows[r], columns[c], param);
         }
 
Index: /trunk/sources/LibSVM/Prediction.cs
===================================================================
--- /trunk/sources/LibSVM/Prediction.cs	(revision 2414)
+++ /trunk/sources/LibSVM/Prediction.cs	(revision 2415)
@@ -24,7 +24,7 @@
 namespace SVM
 {
-    /// <remarks>
+    /// <summary>
     /// Class containing the routines to perform class membership prediction using a trained SVM.
-    /// </remarks>
+    /// </summary>
     public static class Prediction
     {
Index: /trunk/sources/LibSVM/Problem.cs
===================================================================
--- /trunk/sources/LibSVM/Problem.cs	(revision 2414)
+++ /trunk/sources/LibSVM/Problem.cs	(revision 2415)
@@ -21,10 +21,12 @@
 using System.IO;
 using System.Collections.Generic;
+using System.Threading;
+using System.Globalization;
 
 namespace SVM
 {
-    /// <remarks>
+    /// <summary>
     /// Encapsulates a problem, or set of vectors which must be classified.
-    /// </remarks>
+    /// </summary>
 	[Serializable]
 	public class Problem
@@ -119,4 +121,6 @@
         public static Problem Read(Stream stream)
         {
+            TemporaryCulture.Start();
+
             StreamReader input = new StreamReader(stream);
             List<double> vy = new List<double>();
@@ -143,4 +147,6 @@
             }
 
+            TemporaryCulture.Stop();
+
             return new Problem(vy.Count, vy.ToArray(), vx.ToArray(), max_index);
         }
@@ -153,4 +159,6 @@
         public static void Write(Stream stream, Problem problem)
         {
+            TemporaryCulture.Start();
+
             StreamWriter output = new StreamWriter(stream);
             for (int i = 0; i < problem.Count; i++)
@@ -162,4 +170,6 @@
             }
             output.Flush();
+
+            TemporaryCulture.Stop();
         }
 
Index: /trunk/sources/LibSVM/Properties/AssemblyInfo.cs
===================================================================
--- /trunk/sources/LibSVM/Properties/AssemblyInfo.cs	(revision 2414)
+++ /trunk/sources/LibSVM/Properties/AssemblyInfo.cs	(revision 2415)
@@ -6,10 +6,10 @@
 // set of attributes. Change these attribute values to modify the information
 // associated with an assembly.
-[assembly: AssemblyTitle("LibSVM")]
-[assembly: AssemblyDescription("")]
+[assembly: AssemblyTitle("SVM.NET")]
+[assembly: AssemblyDescription("A .NET Support Vector Machine library adapted from libsvm")]
 [assembly: AssemblyConfiguration("")]
 [assembly: AssemblyCompany("Matthew Johnson")]
-[assembly: AssemblyProduct("SVM.NET Library")]
-[assembly: AssemblyCopyright("Copyright (C) 2008 Matthew Johnson")]
+[assembly: AssemblyProduct("SVM.NET")]
+[assembly: AssemblyCopyright("Copyright ©  Matthew Johnson 2009")]
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
@@ -21,5 +21,5 @@
 
 // The following GUID is for the ID of the typelib if this project is exposed to COM
-[assembly: Guid("1f115aaf-e714-4341-b2ad-5e84d30b6a1a")]
+[assembly: Guid("803d4e74-70db-432e-a4da-32e7a021eec2")]
 
 // Version information for an assembly consists of the following four values:
@@ -30,4 +30,6 @@
 //      Revision
 //
-[assembly: AssemblyVersion("2.84")]
-[assembly: AssemblyFileVersion("2.84")]
+// You can specify all the values or you can default the Revision and Build Numbers 
+// by using the '*' as shown below:
+[assembly: AssemblyVersion("1.6.3")]
+[assembly: AssemblyFileVersion("1.6.3")]
Index: /trunk/sources/LibSVM/RangeTransform.cs
===================================================================
--- /trunk/sources/LibSVM/RangeTransform.cs	(revision 2414)
+++ /trunk/sources/LibSVM/RangeTransform.cs	(revision 2415)
@@ -20,12 +20,69 @@
 using System;
 using System.IO;
+using System.Threading;
+using System.Globalization;
 
 namespace SVM
 {
-    /// <remarks>
+    /// <summary>
     /// Class which encapsulates a range transformation.
-    /// </remarks>
+    /// </summary>
     public class RangeTransform : IRangeTransform
     {
+        /// <summary>
+        /// Default lower bound for scaling (-1).
+        /// </summary>
+        public const int DEFAULT_LOWER_BOUND = -1;
+        /// <summary>
+        /// Default upper bound for scaling (1).
+        /// </summary>
+        public const int DEFAULT_UPPER_BOUND = 1;
+
+        /// <summary>
+        /// Determines the Range transform for the provided problem.  Uses the default lower and upper bounds.
+        /// </summary>
+        /// <param name="prob">The Problem to analyze</param>
+        /// <returns>The Range transform for the problem</returns>
+        public static RangeTransform Compute(Problem prob)
+        {
+            return Compute(prob, DEFAULT_LOWER_BOUND, DEFAULT_UPPER_BOUND);
+        }
+        /// <summary>
+        /// Determines the Range transform for the provided problem.
+        /// </summary>
+        /// <param name="prob">The Problem to analyze</param>
+        /// <param name="lowerBound">The lower bound for scaling</param>
+        /// <param name="upperBound">The upper bound for scaling</param>
+        /// <returns>The Range transform for the problem</returns>
+        public static RangeTransform Compute(Problem prob, double lowerBound, double upperBound)
+        {
+            double[] minVals = new double[prob.MaxIndex];
+            double[] maxVals = new double[prob.MaxIndex];
+            for (int i = 0; i < prob.MaxIndex; i++)
+            {
+                minVals[i] = double.MaxValue;
+                maxVals[i] = double.MinValue;
+            }
+            for (int i = 0; i < prob.Count; i++)
+            {
+                for (int j = 0; j < prob.X[i].Length; j++)
+                {
+                    int index = prob.X[i][j].Index - 1;
+                    double value = prob.X[i][j].Value;
+                    minVals[index] = Math.Min(minVals[index], value);
+                    maxVals[index] = Math.Max(maxVals[index], value);
+                }
+            }
+            for (int i = 0; i < prob.MaxIndex; i++)
+            {
+                if (minVals[i] == double.MaxValue || maxVals[i] == double.MinValue)
+                {
+                    minVals[i] = 0;
+                    maxVals[i] = 0;
+                }
+            }
+            return new RangeTransform(minVals, maxVals, lowerBound, upperBound);
+        }
+
         private double[] _inputStart;
         private double[] _inputScale;
@@ -72,5 +129,5 @@
         {
             Node[] output = new Node[input.Length];
-            for (int i = 0; i < _length; i++)
+            for (int i = 0; i < output.Length; i++)
             {
                 int index = input[i].Index;
@@ -104,4 +161,6 @@
         public static void Write(Stream stream, RangeTransform r)
         {
+            TemporaryCulture.Start();
+
             StreamWriter output = new StreamWriter(stream);
             output.WriteLine(r._length);
@@ -116,4 +175,6 @@
             output.WriteLine("{0} {1}", r._outputStart, r._outputScale);
             output.Flush();
+
+            TemporaryCulture.Stop();
         }
 
@@ -161,4 +222,6 @@
         public static RangeTransform Read(Stream stream)
         {
+            TemporaryCulture.Start();
+
             StreamReader input = new StreamReader(stream);
             int length = int.Parse(input.ReadLine());
@@ -174,4 +237,7 @@
             double outputStart = double.Parse(parts[0]);
             double outputScale = double.Parse(parts[1]);
+
+            TemporaryCulture.Stop();
+
             return new RangeTransform(inputStart, inputScale, outputStart, outputScale, length);
         }
Index: /trunk/sources/LibSVM/SVMExtensions.cs
===================================================================
--- /trunk/sources/LibSVM/SVMExtensions.cs	(revision 2415)
+++ /trunk/sources/LibSVM/SVMExtensions.cs	(revision 2415)
@@ -0,0 +1,17 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace SVM
+{
+    internal static class SVMExtensions
+    {
+        public static void SwapIndex<T>(this T[] list, int i, int j)
+        {
+            T tmp = list[i];
+            list[i] = list[j];
+            list[j] = tmp;
+        }
+    }
+}
Index: /trunk/sources/LibSVM/Scaling.cs
===================================================================
--- /trunk/sources/LibSVM/Scaling.cs	(revision 2414)
+++ /trunk/sources/LibSVM/Scaling.cs	(revision 2415)
@@ -22,64 +22,10 @@
 namespace SVM
 {
-    /// <remarks>
+    /// <summary>
     /// Deals with the scaling of Problems so they have uniform ranges across all dimensions in order to
     /// result in better SVM performance.
-    /// </remarks>
+    /// </summary>
     public static class Scaling
     {
-        /// <summary>
-        /// Default lower bound for scaling (-1).
-        /// </summary>
-        public const int DEFAULT_LOWER_BOUND = -1;
-        /// <summary>
-        /// Default upper bound for scaling (1).
-        /// </summary>
-        public const int DEFAULT_UPPER_BOUND = 1;
-
-        /// <summary>
-        /// Determines the Range transform for the provided problem.  Uses the default lower and upper bounds.
-        /// </summary>
-        /// <param name="prob">The Problem to analyze</param>
-        /// <returns>The Range transform for the problem</returns>
-        public static RangeTransform DetermineRange(Problem prob)
-        {
-            return DetermineRangeTransform(prob, DEFAULT_LOWER_BOUND, DEFAULT_UPPER_BOUND);
-        }
-        /// <summary>
-        /// Determines the Range transform for the provided problem.
-        /// </summary>
-        /// <param name="prob">The Problem to analyze</param>
-        /// <param name="lowerBound">The lower bound for scaling</param>
-        /// <param name="upperBound">The upper bound for scaling</param>
-        /// <returns>The Range transform for the problem</returns>
-        public static RangeTransform DetermineRangeTransform(Problem prob, double lowerBound, double upperBound)
-        {
-            double[] minVals = new double[prob.MaxIndex];
-            double[] maxVals = new double[prob.MaxIndex];
-            for (int i = 0; i < prob.MaxIndex; i++)
-            {
-                minVals[i] = double.MaxValue;
-                maxVals[i] = double.MinValue;
-            }
-            for (int i = 0; i < prob.Count; i++)
-            {
-                for (int j = 0; j < prob.X[i].Length; j++)
-                {
-                    int index = prob.X[i][j].Index-1;
-                    double value = prob.X[i][j].Value;
-                    minVals[index] = Math.Min(minVals[index], value);
-                    maxVals[index] = Math.Max(maxVals[index], value);
-                }
-            }
-            for (int i = 0; i < prob.MaxIndex; i++)
-            {
-                if (minVals[i] == double.MaxValue || maxVals[i] == double.MinValue)
-                {
-                    minVals[i] = 0;
-                    maxVals[i] = 0;
-                }
-            }
-            return new RangeTransform(minVals, maxVals, lowerBound, upperBound);
-        }
         /// <summary>
         /// Scales a problem using the provided range.  This will not affect the parameter.
@@ -88,5 +34,5 @@
         /// <param name="range">The Range transform to use in scaling</param>
         /// <returns>The Scaled problem</returns>
-        public static Problem Scale(Problem prob, IRangeTransform range)
+        public static Problem Scale(this IRangeTransform range, Problem prob)
         {
             Problem scaledProblem = new Problem(prob.Count, new double[prob.Count], new Node[prob.Count][], prob.MaxIndex);
